////////////////////////////////////////////////////////////
// Exercice 0

// Réécrire la fonction f2() précédente en utilisant une IIFE au lieu d’une déclaration const j.
// Sans utiliser de const ou de let, on utilise une IIFE pour copier la valeur de i dans une
// variable x locale à l'IIFE

function g1(){
  let tab = [];
  for(var i = 0; i < 3; ++i) {
    (function(x){
      tab.push( () => x );
    }
    )(i)
  }
  return tab.map( f => f() );
}

////////////////////////////////////////////////////////////
// Exercice 2

function garde_entiers_pairs(tab) {
  return tab
    .filter(n => typeof n === "number" && n % 2 == 0);
}

////////////////////////////////////////////////////////////
// Exercice 3
////////////////////////////////////////
// données exemple
const donnees_exemple = 
    [
        { "titre":"CM3 : programmation fonctionnelle en js",
          "date": "2017-02-27",
          "contenu": `Ce cours introduit les notions de programmation avec des fonctions d'ordre supérieur.

Après avoir revu la définition de fonction, on abordera les fonctions renvoyées en résultat, ainsi que la l'utilisation de valeurs extérieures à la définition de la fonction.

Outre la manipulation des fonctions commes objets de première classe, la notion de fermeture est un des principaux concepts à retenir de ce cours.`},
        
        { "titre": "CM1 : introduction à js (1/2)",
          "date": "2017-01-30",
          "contenu": `Ce cours décrit les bases du langage JavaScript.

On y verra en particulier les valeurs, les types, les structures de tableau et de dictionnaire. Enfin on abordera la définition des fonctions et les méthodes.` },
        
        { "titre": "CM2 : introduction à js (2/2)",
          "date": "2017-02-06",
          "contenu": `Ce cours poursuit la présentation du langage Javascript.

Dans ce cours, on abordera les APIs de chaînes de caractères et de tableaux, ainsi que les fonctions passées en argument.`},
        
        { "titre": "CM4 : programmation asynchrone",
          "date": "2017-03-06",
          "contenu": `Ce cours aborde les notions de programmation asynchrone.

Après quelques notions fondamentales sur les fonction introduites via le lamnbda-calcul, ce cours abordera des constructions standard de programmation asynchrone, telle que les callbacks et les promesses.`},

        { "titre": "L'UE LIFAP5 est créée",
          "date": "2016-09-01",
          "contenu": "Création de l'UE LIFAP5: programmation fonctionnelle pour le Web.\n\nCette UE aborde la programmation fonctionnelle à travers Javascript et la programmation Web." }
    ];
////////////////////////////////////////

function trie_articles_date(nouvelles) {
  const res = Array.from(nouvelles);
  res.sort((n1, n2) => n1.date < n2.date ? 1 : n1.date > n2.date ? -1 : 0);
  return res;
}

////////////////////////////////////////

function formate_titre(nouvelle) {
  return `<li>${nouvelle.date}: ${nouvelle.titre}</li>`;
}

////////////////////////////////////////

function liste_nouvelles_html(nouvelles) {
  const nouvelles_html =
        trie_articles_date(nouvelles)
        .map(formate_titre)
        .join('\n');
  return `<ul>\n${nouvelles_html}</ul>\n`;
}

////////////////////////////////////////////////////////////
// Exercice 3.2

function filtre_mois_annee(nouvelles, mois, annee) {
  return nouvelles.filter(function(n) {
    const splitted_date = n.date.split('-').map(Number);
    const a = splitted_date[0];
    const m = splitted_date[1];
    return !isNaN(a) && !isNaN(m)
      && a === Number(annee) && m === Number(mois);
  });
}

////////////////////////////////////////

function maj_liste_nouvelles() {
  const mois = document.getElementById("input-mois").value;
  const annee = document.getElementById("input-annee").value;
  const filtrees = filtre_mois_annee(donnees_exemple, mois, annee);
  const liste_html = liste_nouvelles_html(filtrees);
  document.getElementById("elt-nouvelles").innerHTML = liste_html;
}

////////////////////////////////////////

// Fonction appelée une fois la page HTML chargée
function init_3_2() {
  console.log("Initialisation pour l'exercice 3.2");
  document.getElementById("btn-upt-liste").onclick = maj_liste_nouvelles;
}


////////////////////////////////////////////////////////////
// Exercice 3.3

function liste_to_options(valeurs) {
  const options = valeurs
        .map((v,i) => `  <option value="${v}" ${i === 0 ? 'selected="true"' : ''}>${v}</option>`)
        .join('\n')
  return `${options}`;
}

function maj_liste_nouvelles2(nouvelles, mois, annee) {
  const filtrees = filtre_mois_annee(nouvelles, mois, annee);
  const liste_html = liste_nouvelles_html(filtrees);
  document.getElementById("elt-nouvelles").innerHTML = liste_html;
}

function elimine_doublons_trie(liste) {
  const asSet = new Set(liste);
  let asTab = Array.from(asSet.values());
  asTab.sort();
  return asTab;
}

function mois_de_annee(nouvelles, annee) {
  const nAnnee = Number(annee);
  let filtered = nouvelles
        .map(n => n.date)
        .map(d => d.split("-"))
        .filter(dl => Number(dl[0]) === nAnnee)
      .map(dl => dl[1]); // le mois
  return elimine_doublons_trie(filtered);
}

function maj_mois(nouvelles, annee) {
  const mois_annee = mois_de_annee(nouvelles, annee);
  const select = document.getElementById("select-mois");
  select.innerHTML = liste_to_options(mois_annee)
  maj_liste_nouvelles2(nouvelles, select.value, annee);
}
                       
function annees(nouvelles) {
  return elimine_doublons_trie(
    nouvelles
      .map(n => n.date.split('-')[0])
  );
}

function change_annee() {
  const annee = document.getElementById("select-annee").value;
  maj_mois(trie_articles_date(donnees_exemple), annee);
}

function change_mois() {
  const mois = document.getElementById("select-mois").value;
  const annee = document.getElementById("select-annee").value;
  maj_liste_nouvelles2(trie_articles_date(donnees_exemple), mois, annee);
}

// Fonction appelée une fois la page HTML chargée
function init_3_3() {
  console.log("Initialisation pour l'exercice 3.3");
  const annee_html = liste_to_options(annees(donnees_exemple));
  document.getElementById("select-annee").innerHTML = annee_html;
  document.getElementById("select-annee").onchange = change_annee;
  document.getElementById("select-mois").onchange = change_mois;
  change_annee();
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// Code permettant d'utiliser les fonctions ci-dessus dans la page LIFAP5-TP2.html
document.addEventListener('DOMContentLoaded', function(){

  
  if (document.getElementById("title-test-tp2") == null) { // garde pour ne pas exécuter dans la page des tests unitaires.
  
    document.getElementById("elt-nouvelles").innerHTML = liste_nouvelles_html(donnees_exemple);

    init_3_2();

    init_3_3();
    
  }
  
}, false);

